if (typeof Object.assign != 'function') {
    Object.assign = function (target) {
        if (target === null) {
            return null;
        }

        var result = Object(target);
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];
            if (source !== null) {
                for (var key in source) {
                    if (source.hasOwnProperty(key)) {
                        result[key] = source[key];
                    }
                }
            }
        }
        return result;
    };
}

// http://stackoverflow.com/questions/27936772/deep-object-merging-in-es6-es7


/**
 * Simple is object check.
 * @param item
 * @returns {boolean}
 */
export function isObject(item) {
    return (item && typeof item === 'object' && !Array.isArray(item) && item !== null);
}

export function mergeDeep(target, source) {
    if (isObject(target) && isObject(source)) {
        Object.keys(source).forEach(key => {
            if (isObject(source[key])) {
                if (!target[key]) Object.assign(target, { [key]: {} });
                mergeDeep(target[key], source[key]);
            } else {
                Object.assign(target, { [key]: source[key] });
            }
        });
    }
    return target;
}
